---
apiVersion: v1
kind: ConfigMap
metadata:
  name: {{ include "common.names.fullname" . }}
  labels:
    {{- include "common.labels.standard" . | nindent 4 }}
    {{- if .Values.configMap.additionalLabels }}
    {{- include "common.tplvalues.render" ( dict "value" .Values.configMap.additionalLabels "context" $) | nindent 4 }}
    {{- end }}
  annotations:
    {{- if .Values.configMap.additionalAnnotations }}
    {{- include "common.tplvalues.render" ( dict "value" .Values.configMap.additionalAnnotations "context" $) | nindent 4 }}
    {{- end }}
data:
  php.ini: |
    {{- .Values.config.customPhpConfig | default "" | nindent 4 }}
  roundcube.config.php: |
    <?php
    {{ range $plugin, $settings := .Values.config.plugins }}
    {{- if $settings -}}{{- if $settings.enabled -}}
    // generated configuration for plugin {{ $plugin }}
    {{- range $key, $value := $settings.config }}
    $config['{{ if (not $settings.configOmitNamePrefix) }}{{ $plugin }}_{{ end }}{{ $key }}'] = {{ include "roundcube.helm2php" $value }};
    {{- end -}}{{- end -}}{{- end }}
    {{ end }}

    // ingress path config
    {{ if .Values.ingress.enabled }}
    $config['request_path'] = "{{ .Values.ingress.path }}";
    {{ end }}

    // custom roundcube config
    {{- .Values.config.customRoundcubeConfig | default "" | nindent 4 }}
  php-fpm.conf: |
    {{- .Values.config.customPhpFpmConfig | default "" | nindent 4 }}
  nginx.conf: |
    events {

    }

    http {
      include       /etc/nginx/mime.types;
      default_type  application/octet-stream;

      keepalive_timeout  65;
      client_max_body_size {{ .Values.config.uploadMaxFilesize }};

      server {
        listen {{ .Values.deployment.port }} default_server;
        listen [::]:{{ .Values.deployment.port }} default_server;

        root /var/www/html;
        server_name _;

        index index.php;

        location / {
          try_files $uri $uri/ =404;
        }
        location /_healthy {
          access_log off;
          return 200;
        }
        location ~ \.php(?:$|/) {
          fastcgi_split_path_info ^(.+\.php)(.*)$;

          include fastcgi_params;
          fastcgi_param REQUEST_METHOD $request_method;
          fastcgi_param SCRIPT_FILENAME $document_root$fastcgi_script_name;
          fastcgi_param PATH_INFO       $fastcgi_path_info;
          fastcgi_pass localhost:9000;
        }
      }
    }
